Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.modelmbean
Class DescriptorSupport

    java.lang.Object
      |
      +--javax.management.modelmbean.DescriptorSupport

All Implemented Interfaces:
  Descriptor, java.io.Serializable

public class DescriptorSupport
extends java.lang.Object
implements Descriptor

This class represents the metadata set for a ModelMBean element. A descriptor is part of the ModelMBeanInfo, ModelMBeanNotificationInfo, ModelMBeanAttributeInfo, ModelMBeanConstructorInfo, and ModelMBeanParameterInfo.

A descriptor consists of a collection of fields. Each field is in fieldname=fieldvalue format. Field names are not case sensitive, case will be preserved on field values.

All field names and values are not predefined. New fields can be defined and added by any program. Some fields have been predefined for consistency of implmentation and support by the ModelMBeanInfo ModelMBean*Info, and ModelMBean classes.

Author:
  Young Yang
See Also:
  Serialized Form

Constructor Summary
`DescriptorSupport()`
`DescriptorSupport(DescriptorSupport initDescriptor)` Descriptor constructor taking a Descriptor as parameter.
`DescriptorSupport(int initNumFields)` Descriptor constructor.
`DescriptorSupport(java.lang.String xmlString)` Descriptor constructor taking an XML String.
`DescriptorSupport(java.lang.String[] fields)` Constructor taking fields in the fieldName=fieldValue format.
`DescriptorSupport(java.lang.String[] fieldNames, java.lang.Object[] fieldValues)` Constructor taking field names and field values.

Method Summary
`java.lang.Object` | `clone()` Returns a new Descriptor which is a duplicate of the Descriptor.
`java.lang.String[]` | `getFieldNames()` Returns all the fields names in the descriptor.
`java.lang.String[]` | `getFields()` Returns all the fields in the descriptor
`java.lang.Object` | `getFieldValue(java.lang.String fieldName)` returns the string value for a specific fieldname
`java.lang.Object[]` | `getFieldValues(java.lang.String[] fieldNames)` Returns all the field values in the descriptor as an array of Objects.
`boolean` | `isValid()` Returns true if fieldValues are checked to be sure they are legal for the fieldNames.
`static void` | `main(java.lang.String[] args)`
`void` | `removeField(java.lang.String fieldName)` Removes a field from the descriptor
`void` | `setField(java.lang.String fieldName, java.lang.Object fieldValue)` Sets the string value for a specific fieldname.
`void` | `setFields(java.lang.String[] fieldNames, java.lang.Object[] fieldValues)` Sets all Fields in the list to the new value in with the same index in the fieldValue array.
`java.lang.String` | `toString()`
`java.lang.String` | `toXMLString()`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DescriptorSupport

    public DescriptorSupport()

### DescriptorSupport

    public DescriptorSupport(int initNumFields)
                      throws MBeanException,
                             RuntimeOperationsException

  Descriptor constructor. Takes as parameter the initial capacity of the Map that stores the descriptor fields. Capacity will grow as needed.

Parameters:
  `initNumFields` - The initial capacity of the Map that stores the descriptor fields.
Throws:
  `RuntimeOperationsException` - for illegal value for maxNumFields ( <= 0)
  `MBeanException`

### DescriptorSupport

    public DescriptorSupport(DescriptorSupport initDescriptor)

  Descriptor constructor taking a Descriptor as parameter. Creates a new descriptor initialized to the values of the descriptor passed in parameter.

Parameters:
  `initDescriptor` - the descriptor to be used to initialize the constructed descriptor. If it is null or contains no descriptor fields, an empty Descriptor will be created.
Throws:
  `RuntimeOperationsException` - for illegal value for inDescr. inDescr cannot be null. If the descriptor fails for any reason, this exception will be thrown.

### DescriptorSupport

    public DescriptorSupport(java.lang.String xmlString)
                      throws MBeanException,
                             RuntimeOperationsException,
                             XMLParseException

  Descriptor constructor taking an XML String. This method is part of this implementation and not required by the JMX Specification

Parameters:
  `xmlString` - An XML-formatted string used to populate this Descriptor. The format will be: ... All fields values will be created as Strings. If the field values are not Strings, the programmer will have to reset or convert these fields correctly. Fields which are not String objects will have toString() called on them to create the value. You will not be able to reconstruct these objects unless they have been specifically setup to support toString() into a meaningfull format and have a matching constructor that accepts a String in the same format.
Throws:
  `MBeanException`
  `RuntimeOperationsException`
  `XMLParseException`

### DescriptorSupport

    public DescriptorSupport(java.lang.String[] fieldNames,
                             java.lang.Object[] fieldValues)
                      throws RuntimeOperationsException

  Constructor taking field names and field values. The array and array elements cannot be null.

Parameters:
  `fieldNames` - String array of field names. No elements of this array can be null.
  `fieldValues` - Object array of the corresponding field values. Elements of the array can be null. The fieldValue must be valid for the fieldName. Note: array sizes of parameters should match. If both arrays are null or empty, then an empty descriptor is created. No exception is thrown.
Throws:
  `RuntimeOperationsException` - for illegal value for field Names or field Values. The array lengths must be equal. If the descriptor construction fails for any reason, this exception will be thrown.

### DescriptorSupport

    public DescriptorSupport(java.lang.String[] fields)

  Constructor taking fields in the fieldName=fieldValue format.

Parameters:
  `fields` - String array of with each element containing a field name and value. If this array is null or empty, then the default constructor will be executed. Null strings or empty strings will be ignored. Note: each string should be of the form fieldName=fieldValue, with no imbedded blanks or other punctuation.
Throws:
  `RuntimeOperationsException` - for illegal value for field Names or field Values. The field must contain an "=". "=fieldValue", "fieldName", and "fieldValue" are illegal. FieldName cannot be null. "fieldName=" will cause the value to be null. If the descriptor construction fails for any reason, this exception will be thrown.

Method Detail

### getFieldValue

    public java.lang.Object getFieldValue(java.lang.String fieldName)
                                   throws RuntimeOperationsException

  returns the string value for a specific fieldname

  Specified by:
    `getFieldValue` in interface `Descriptor`
  Parameters:
    `fieldName` - The field name in question; if not found, null is returned.
  Returns:
    String Field value
  Throws:
    `RuntimeOperationsException` - for illegal value (null or empty string) for field Names.

### setField

    public void setField(java.lang.String fieldName,
                         java.lang.Object fieldValue)
                  throws RuntimeOperationsException

  Sets the string value for a specific fieldname. The value must be valid for the field. If the field does not exist, it is added. if it does exist, the value is replaced.

  Specified by:
    `setField` in interface `Descriptor`
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names.

### getFields

    public java.lang.String[] getFields()

  Returns all the fields in the descriptor

  Specified by:
    `getFields` in interface `Descriptor`
  Returns:
    String array of fields in the format fieldName=fieldValue. If there are no fields in the descriptor, then String[0] is returned. If a fieldValue is an object then the toString() method is called on it and its returned value is used as the value for the field enclosed in parens.
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or Values.

### getFieldNames

    public java.lang.String[] getFieldNames()

  Returns all the fields names in the descriptor.

  Specified by:
    `getFieldNames` in interface `Descriptor`
  Returns:
    String array of fields names. If the descriptor is empty, you will get an empty array.

### getFieldValues

    public java.lang.Object[] getFieldValues(java.lang.String[] fieldNames)

  Returns all the field values in the descriptor as an array of Objects. The retuned values are in the same order as the fieldNames String array parameter.

  Specified by:
    `getFieldValues` in interface `Descriptor`
  Parameters:
    `fieldNames` - String array of the names of the fields that the values should be returned for. If the array is empty then an empty array will be returned. If the array is 'null' then all values will be returned. If a field name in the array does not exist, then null is returned for the matching array element being returned.
  Returns:
    Object array of field values. If the descriptor is empty, you will get an empty array.

### setFields

    public void setFields(java.lang.String[] fieldNames,
                          java.lang.Object[] fieldValues)
                   throws RuntimeOperationsException

  Sets all Fields in the list to the new value in with the same index in the fieldValue array. Array sizes must match. The field value will be validated before it is set. If it is not valid, then an exception will be thrown. If the arrays are empty, then no change will take effect.

  Specified by:
    `setFields` in interface `Descriptor`
  Parameters:
    `fieldNames` - String array of field names. The array and array elements cannot be null.
    `fieldValues` - Object array of the corresponding field values. The array cannot be null. Elements of the array can be null.
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or field Values. Niether can be null. The array lengths must be equal. If the descriptor construction fails for any reason, this exception will be thrown.

### clone

    public java.lang.Object clone()
                           throws RuntimeOperationsException

  Returns a new Descriptor which is a duplicate of the Descriptor.

  Specified by:
    `clone` in interface `Descriptor`
  Overrides:
    `clone` in class `java.lang.Object`
  Throws:
    `RuntimeOperationsException` - for illegal value for field Names or field Values. If the descriptor construction fails for any reason, this exception will be thrown.

### removeField

    public void removeField(java.lang.String fieldName)

  Removes a field from the descriptor

  Specified by:
    `removeField` in interface `Descriptor`
  Parameters:
    `fieldName` - String name of the field to be removed. If the field is not found no exception is thrown.

### isValid

    public boolean isValid()
                    throws RuntimeOperationsException

  Returns true if fieldValues are checked to be sure they are legal for the fieldNames. This implementation returns false if: name or descriptorType fields are null class, role, getMethod and setMethod, if defined, must not be null persistPeriod, currencyTimeLimit, lastUpdatedTimeStamp, lastReturnedTimeStamp must numerics greater than -1. iterable, log, export must be t, f, true, or false visibility must be between 1 and 4 severity must be betwen 0 and 5 persistPolicy must be OnUpdate,OnTimer,NoMoreOftenThan,Always,or Never is must not be case sensitive.

  Specified by:
    `isValid` in interface `Descriptor`
  Throws:
    `RuntimeOperationsException` - If the validity checking fails for any reason, this exception will be thrown.

### toXMLString

    public java.lang.String toXMLString()

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### main

    public static void main(java.lang.String[] args)
                     throws java.lang.Exception

    `java.lang.Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD